public class Main
{
	public static void main(String[] args)
	{
		//Exo 3, question 3
		LectureFichier fichier = new LectureFichier("liste_pokemons.txt");
		CartePokemon tete_liste = null;
		CartePokemon temp;
        
		while(fichier.il_reste_des_lignes())
		{
			String n = fichier.lire_nom_Pokemon();
			double v = fichier.lire_valeur_Pokemon();
			int r = fichier.lire_rarete_Pokemon();

			temp = creerPokemon(n, r, v, tete_liste);
			tete_liste=temp;			
		} 



		//Test exo 3, question 4
		afficherListePokemon(tete_liste);



		//Test exo 3, question 5
		System.out.println("A la position 5 :");
		afficherPokemonALaPosition(tete_liste, 5);
		System.out.println("A la position 20 :");
		afficherPokemonALaPosition(tete_liste, 20);



		

	}

	
	//Exo 2, question 3
	public static void afficherPokemon(CartePokemon p)
	{
		System.out.println("*****Pokemon******");
		System.out.println(p.nom);
		System.out.println(p.valeur);
		System.out.println(p.rarete);
		System.out.println("******************");
	}

	

	//Exo 2, question 4 -- modifie pour etre plus pratique comme autorise dans la question 1 de l'exo 4
	public static boolean sontEgaux(CartePokemon a, CartePokemon b)
	{
		//je retourne directement un booleen qui vaut true si les deux Pokemon sont egaux champ par champ		
		return( a.nom.equals(b.nom) && a.valeur==b.valeur && a.rarete==b.rarete );
	}


	//Exo 2, question 5 -- modifie selon exercice 3, question 2
	public static CartePokemon creerPokemon(String nom, int rarete, double valeur, CartePokemon next)
	{
		CartePokemon r = new CartePokemon();
		r.nom = nom;
		r.rarete = rarete;
		r.valeur = valeur;
		r.suivant = next;
		return r;
	}


	//Exo 3, question 4
	public static void afficherListePokemon(CartePokemon tete)
	{
		//On parcourt la liste du debut a la fin, et on affiche chaque element
		CartePokemon temp = tete;
		while(temp!=null)
		{
			afficherPokemon(temp);
			temp = temp.suivant;
		}
	}


	//Exo 3, question 5
	public static void afficherPokemonALaPosition(CartePokemon tete, int position)
	{
		//Position plus petite que un... erreur !
		if(position < 1)
		{
			System.out.println("La position doit etre superieure a 1.");
		}
		else
		{
			//Sinon, on parcourt la liste et on s'arrete quand on a parcouru position elements
			int cpt;
			CartePokemon temp = tete;
			for(cpt=1; cpt<position && temp != null; cpt=cpt+1) //Le parcours s'arrete quand on sort de la liste ou quand on trouve l'element demande
			{
				temp=temp.suivant;
			}

			if(temp==null)
			{
				//Si on est sorti de la liste, c'est que la position est en dehors de la liste
				System.out.println("La position demandee est en dehors de la liste.");
			}
			else
			{
				//on affiche le pokemon demande
				afficherPokemon(temp);
			}
		}
	}


	
	
}

