public class Main
{
	public static void main(String[] args)
	{
		//Exo 3, question 3
		LectureFichier fichier = new LectureFichier("liste_pokemons.txt");
		CartePokemon tete_liste = null;
		CartePokemon temp;
        
		while(fichier.il_reste_des_lignes())
		{
			String n = fichier.lire_nom_Pokemon();
			double v = fichier.lire_valeur_Pokemon();
			int r = fichier.lire_rarete_Pokemon();

			temp = creerPokemon(n, r, v, tete_liste);
			tete_liste=temp;			
		} 



		//Test Exo 4, question 1
		CartePokemon p1 = creerPokemon("Pikachu", 4, 23.5, null);
		CartePokemon p2 = creerPokemon("Dracofeu", 18, 12.2, null);
		
		afficherPokemon(p1);
		if(contient(tete_liste, p1))
		{
			System.out.println("Est dans la liste");
		}
		else
		{
			System.out.println("N'est pas dans la liste");
		}

		afficherPokemon(p2);
		if(contient(tete_liste, p2))
		{
			System.out.println("Est dans la liste");
		}
		else
		{
			System.out.println("N'est pas dans la liste");
		}


		//test exo 4, question 2
		System.out.println("Taille de la liste :");
		System.out.println(taille(tete_liste));


		//test exo 4, question 3
		CartePokemon p3 = creerPokemon("Pikachu2", 4, 23.5, null);
		CartePokemon p4 = creerPokemon("Dracofeu2", 18, 12.2, null);

		insererEnTete(tete_liste, p3);
		insererEnQueue(tete_liste, p4);
		


		//test exo 4, question 4
		CartePokemon p5 = creerPokemon("Bulbizarre2", 4, 2.0, null);
		insererALaPosition(tete_liste, p5, 7);
		//test si la fonction refuse bien les positions en dehors de la liste
		//CartePokemon p6 = creerPokemon("Bulbizarre3", 4, 2.0, null);
		//insererALaPosition(tete_liste, p6, 13);

		afficherListePokemon(tete_liste);
	}

	
	//Exo 2, question 3
	public static void afficherPokemon(CartePokemon p)
	{
		System.out.println("*****Pokemon******");
		System.out.println(p.nom);
		System.out.println(p.valeur);
		System.out.println(p.rarete);
		System.out.println("******************");
	}

	

	//Exo 2, question 4 -- modifie pour etre plus pratique comme autorise dans la question 1 de l'exo 4
	public static boolean sontEgaux(CartePokemon a, CartePokemon b)
	{
		//je retourne directement un booleen qui vaut true si les deux Pokemon sont egaux champ par champ		
		return( a.nom.equals(b.nom) && a.valeur==b.valeur && a.rarete==b.rarete );
	}


	//Exo 2, question 5 -- modifie selon exercice 3, question 2
	public static CartePokemon creerPokemon(String nom, int rarete, double valeur, CartePokemon next)
	{
		CartePokemon r = new CartePokemon();
		r.nom = nom;
		r.rarete = rarete;
		r.valeur = valeur;
		r.suivant = next;
		return r;
	}


	//Exo 3, question 4
	public static void afficherListePokemon(CartePokemon tete)
	{
		//On parcourt la liste du debut a la fin, et on affiche chaque element
		CartePokemon temp = tete;
		while(temp!=null)
		{
			afficherPokemon(temp);
			temp = temp.suivant;
		}
	}


	//Exo 3, question 5
	public static void afficherPokemonALaPosition(CartePokemon tete, int position)
	{
		//Position plus petite que un... erreur !
		if(position < 1)
		{
			System.out.println("La position doit etre superieure a 1.");
		}
		else
		{
			//Sinon, on parcourt la liste et on s'arrete quand on a parcouru position elements
			int cpt;
			CartePokemon temp = tete;
			for(cpt=1; cpt<position && temp != null; cpt=cpt+1) //Le parcours s'arrete quand on sort de la liste ou quand on trouve l'element demande
			{
				temp=temp.suivant;
			}

			if(temp==null)
			{
				//Si on est sorti de la liste, c'est que la position est en dehors de la liste
				System.out.println("La position demandee est en dehors de la liste.");
			}
			else
			{
				//on affiche le pokemon demande
				afficherPokemon(temp);
			}
		}
	}


	//Exo 4, question 1
	public static boolean contient(CartePokemon liste, CartePokemon recherche)
	{
		CartePokemon temp = liste;
		//on parcourt toute la liste, du debut a la fin
		while(temp!=null)
		{
			//la fonction sontEgaux a ete modifiee pour renvoyer un booleen directement... je l'utilise pour tester si le pokemon sur lequel je suis en ce moment est egal au pokemon recherche
			if(sontEgaux(temp, recherche))
			{
				//les deux pokemons sont egaux, on arrete le parcourt et on retourne que oui, le pokemon recherche est dans la liste
				return true;
			}
			//le pokemon sur lequel on est n'est pas celui recherche, on passe au suivant
			temp = temp.suivant;
		}
		//on a tout parcouru mais on a pas trouve le pokemon.. il n'est pas dans la liste.
		return false;
	}


	//Exo 4, question 2
	public static int taille(CartePokemon tete)
	{
		int taille = 0;
		CartePokemon temp = tete;
		
		//on parcourt toute la liste du debut a la fin
		while(temp!=null)
		{
			//A chaque nouvel element rencontre dans la liste, on incremente la taille
			taille = taille + 1;
			temp = temp.suivant;
		}

		return taille;
	}


	//Exo 4, question 3
	public static void insererEnTete(CartePokemon liste, CartePokemon a_rajouter)
	{
		//Le probleme ici, c'est que la tete de la liste va changer... Il faudrait donc, a la fin du programme, renvoyer la nouvelle tete de la liste
		//(la carte que l'on rajoute) afin que, dans le main, l'utilisateur mette a jour la tete de liste qu'il manipule
		//Mais on peut s'en sortir sans rien renvoyer... ceci permet a l'utilisateur un confort d'utilisation plus grand de la fonction... il n'a pas a s'occuper de mettre a jour la tete de la 
		//liste car la fonction va le faire pour lui.
		
		//La strategie, c'est de placer la carte a rajouter en seconde position, et d'echanger toutes les informations entre la tete et la seconde carte... A la fin, la tete de la liste n'aura pas change
		//mais les informations contenues a l'interieur auront change (la boite est restee la meme, mais les informations dans la boite auront change)

		a_rajouter.suivant = liste.suivant;
		liste.suivant=a_rajouter;

		//On intervertit toutes les donnees contenues dans a_rajouter et liste
		String temps = a_rajouter.nom;
		a_rajouter.nom = liste.nom;
		liste.nom = temps;

		double tempv = a_rajouter.valeur;
		a_rajouter.valeur = liste.valeur;
		liste.valeur = tempv;

		int tempr = a_rajouter.rarete;
		a_rajouter.rarete = liste.rarete;
		liste.rarete = tempr;
	}


	//Exo 4, question 3
	public static void insererEnQueue(CartePokemon liste, CartePokemon a_rajouter)
	{
		CartePokemon parcours = liste;
		while(parcours.suivant != null)
		{
			parcours=parcours.suivant;
		}

		parcours.suivant = a_rajouter;
		a_rajouter.suivant = null; //Ne surtout pas oublier ca
	}


	//Exo 4, question 4
	public static void insererALaPosition(CartePokemon liste, CartePokemon a_rajouter, int position)
	{
		if(position<1)
		{
			System.out.println("Erreur dans la fonction insererALaPosition : la position doit etre superieure ou egale a 1");
		}

		else if(position==1) //Dans ce cas, on appelle la fonction insererEnTete
		{
			insererEnTete(liste, a_rajouter);
		}

		else
		{
			//On va parcourir la liste, et se deplacer juste avant la position demandee... Si la position demandee est trop grande, on affiche une erreur
			//La position demandee doit etre une position valide d'un element de la liste (sinon, on affiche erreur)
			int position_actuelle = 1;
			CartePokemon carte_actuelle = liste;
			for(position_actuelle=1; (position_actuelle!=position-1) && (carte_actuelle.suivant != null); position_actuelle = position_actuelle+1)
			{
				carte_actuelle=carte_actuelle.suivant;
			}

			//Est-on sorti de la boucle car on a atteint la position demandee, ou bien parceque la liste est trop petit par rapport a la position demandee
			//on teste si on a atteint la position demandee et qu'il existe bien une carte a cette position
			if( (position_actuelle == position-1) && (carte_actuelle.suivant != null) )
			{
				//On a trouve la position demandee
				a_rajouter.suivant = carte_actuelle.suivant;
				carte_actuelle.suivant = a_rajouter;
			}
			else
			{
				System.out.println("Erreur dans la fonction insererALaPosition : la position demandee est en dehors de la liste");
			}
		}
	}
	
}

